Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/SOL/solsor_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/SOL/solsor_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/SOL/solsor_tam.F90	(revision 2587)
@@ -19,5 +19,5 @@
       & jpiglo
    USE in_out_manager, ONLY: & ! I/O manager 
-      & nit000
+      & nit000, lwp
    USE sol_oce       , ONLY: & ! solver variables
       & gcdmat,              &
@@ -71,5 +71,6 @@
    USE tstool_tam    , ONLY: &
       & prntst_adj,          &
-      & stdgc
+      & stdgc,               &
+      & prntst_tlm
    
 
@@ -80,6 +81,8 @@
    PUBLIC sol_sor_adj          ! 
    PUBLIC sol_sor_tan          ! 
-   PUBLIC sol_sor_adj_tst      ! called by tst.F90
-
+   PUBLIC sol_sor_adj_tst      ! called by tamtst.F90
+#if defined key_tst_tlm
+   PUBLIC sol_sor_tlm_tst      ! called by tamtst.F90
+#endif
 
 CONTAINS
@@ -194,5 +197,5 @@
       
          ! test of convergence
-         IF ( jn > nmin .AND. MOD( jn-nmin, nmod ) == 0 ) THEN
+         IF ( (jn > nmin .AND. MOD( jn-nmin, nmod ) == 0) .OR. jn==nmax) THEN
 
             SELECT CASE ( nsol_arp )
@@ -232,4 +235,5 @@
          ENDIF
          ! indicator of non-convergence or explosion
+	     IF( jn == nmax ) nitsor(istp) = jn
          IF( jn == nmax .OR. SQRT(epsr)/eps > 1.e+20 ) kindic = -2
          IF( ncut == 999 ) GOTO 999
@@ -318,10 +322,9 @@
       ijmppodd  = MOD(nimpp+njmpp+jpr2di+jpr2dj+1,2)
       ijpr2d = MAX(jpr2di,jpr2dj)
-      icount = 0
 
       ! Fixed number of iterations
       istp = kt - nit000 + 1
       iter = nitsor(istp)
-
+      icount = iter * 2
       !  Output in gcx_ad
       !  ----------------
@@ -330,5 +333,5 @@
 
       !                                                    ! ==============
-      DO jn = 1, iter                                      ! Iterative loop 
+      DO jn = iter, 1, -1                                  ! Iterative loop 
          !                                                 ! ==============
          ! Guess red update
@@ -349,6 +352,5 @@
             END DO
          END DO
-         icount = icount + 1 
-         
+	     icount = icount - 1         
          ! applied the lateral boundary conditions
          IF( MOD(icount,ijpr2d+1) == 0 ) CALL lbc_lnk_e_adj( gcx_ad, c_solver_pt, 1.0_wp )   ! Lateral BCs
@@ -375,6 +377,5 @@
          END DO
 
-         icount = icount + 1 
- 
+	     icount = icount - 1 
          ! applied the lateral boundary conditions
          IF( MOD(icount,ijpr2d+1) == 0 ) CALL lbc_lnk_e_adj( gcx_ad, c_solver_pt, 1.0_wp )   ! Lateral BCs
@@ -418,4 +419,5 @@
          & jk,    &        
          & kindic,&        ! flags fo solver convergence
+         & kmod,  &        ! frequency of test for the SOR solver
          & kt              ! number of iteration
       INTEGER, DIMENSION(jpi,jpj) :: &
@@ -465,6 +467,8 @@
 
       kt=nit000
+      kindic=0
+!      kmod = nmod  ! store frequency of test for the SOR solver
+!      nmod = 1     ! force frequency to one (remove adj_tst dependancy to nn_nmin)
          
-
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -491,5 +495,6 @@
          END DO
       END DO
-
+      ncut = 1 ! reinitilize the solver convergence flag
+      gcr_tl(:,:) = 0.0_wp
       gcb_tl(:,:) = zgcb_tlin(:,:)
       gcx_tl(:,:) = zgcx_tlin(:,:)
@@ -502,5 +507,4 @@
       !--------------------------------------------------------------------
 
-      DO jk = 1, jpk
         DO jj = nldj, nlej
            DO ji = nldi, nlei
@@ -510,5 +514,4 @@
             END DO
          END DO
-      END DO
       !--------------------------------------------------------------------
       ! Compute the scalar product: ( L dx )^T W dy
@@ -520,5 +523,5 @@
       ! Call the adjoint routine: dx^* = L^T dy^*
       !--------------------------------------------------------------------
-
+      gcb_ad(:,:) = 0.0_wp
       gcx_ad(:,:) = zgcx_adin(:,:)
       CALL sol_sor_adj(kt, kindic) 
@@ -533,4 +536,6 @@
       cl_name = 'sol_sor_adj   '
       CALL prntst_adj( cl_name, kumadt, zsp1, zsp2 )
+
+!      nmod = kmod  ! restore initial frequency of test for the SOR solver
 
       DEALLOCATE(      &
@@ -547,4 +552,324 @@
 
    END SUBROUTINE sol_sor_adj_tst
+#if defined key_tst_tlm
+   SUBROUTINE sol_sor_tlm_tst( kumadt )
+      !!-----------------------------------------------------------------------
+      !!
+      !!                  ***  ROUTINE example_adj_tst ***
+      !!
+      !! ** Purpose : Test the tangent routine.
+      !!
+      !! ** Method  : Verify the tangent with Taylor expansion 
+      !!           
+      !!                 M(x+hdx) = M(x) + L(hdx) + O(h^2)
+      !!
+      !!              where  L   = tangent routine
+      !!                     M   = direct routine
+      !!                     dx  = input perturbation (random field)
+      !!                     h   = ration on perturbation 
+      !!   
+      !!    In the tangent test we verify that:
+      !!                M(x+h*dx) - M(x)
+      !!        g(h) = ------------------ --->  1    as  h ---> 0
+      !!                    L(h*dx)
+      !!    and
+      !!                g(h) - 1
+      !!        f(h) = ----------         --->  k (costant) as  h ---> 0
+      !!                    p
+      !!                  
+      !! History :
+      !!        ! 10-02 (A. Vigilant)
+      !!-----------------------------------------------------------------------
+#if defined key_tam
+      !! * Modules used
+      USE solsor             ! Red-Black Successive Over-Relaxation solver
+      USE tamtrj              ! writing out state trajectory
+      USE par_tlm,    ONLY: &
+        & tlm_bch,          &
+        & cur_loop,         &
+        & h_ratio
+      USE istate_mod
+      USE wzvmod             !  vertical velocity
+      USE gridrandom, ONLY: &
+        & grid_rd_sd
+      USE trj_tam
+      USE sol_oce           , ONLY: & ! ocean dynamics and tracers variables
+        & gcb, gcx, ncut
+      USE oce       , ONLY: & ! 
+        & ua, ub, un
+      USE opatam_tst_ini, ONLY: &
+       & tlm_namrd
+      USE tamctl,         ONLY: & ! Control parameters
+       & numtan, numtan_sc
+      !! * Arguments
+      INTEGER, INTENT(IN) :: &
+         & kumadt             ! Output unit
    
+      !! * Local declarations
+      INTEGER ::  &
+         & ji,    &        ! dummy loop indices
+         & jj,    &        
+         & jk,    &        
+         & kindic,&        ! flags fo solver convergence
+         & kt              ! number of iteration
+      INTEGER, DIMENSION(jpi,jpj) :: &
+         & iseed_2d        ! 2D seed for the random number generator
+      REAL(KIND=wp) ::   &
+         & zsp1, zsp2, zsp3, & ! scalar product
+         & zsp_gcb, zsp_gcx, &
+         & zsp,         &
+         & gamma,        &
+         & zgsp1,        &
+         & zgsp2,        &
+         & zgsp3,        &
+         & zgsp4,        &
+         & zgsp5,        &
+         & zgsp6,        &
+         & zgsp7
+      REAL(KIND=wp), DIMENSION(:,:), ALLOCATABLE :: &
+         & zgcb_tlin ,     & ! Tangent input
+         & zgcx_tlin ,     & ! Tangent input
+         & zgcb_out  ,     & ! Direct output
+         & zgcx_out  ,     & ! Direct output
+         & zgcb_wop  ,     & ! Direct output without perturbation
+         & zgcx_wop  ,     & ! Direct output without perturbation
+         & zr             ! 3D random field 
+      CHARACTER(LEN=14) :: cl_name
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
+      CHARACTER (LEN=90)  :: FMT
+      REAL(KIND=wp), DIMENSION(100):: &
+         & zscgcb,zscgcx,             &
+         & zscerrgcb, zscerrgcx
+      INTEGER, DIMENSION(100)::       &
+         & iiposgcb, ijposgcb,          &
+         & iiposgcx, ijposgcx
+      INTEGER::             &
+         & ii,              &
+         & isamp=40,        &
+         & jsamp=40,        &
+         & numsctlm
+     REAL(KIND=wp), DIMENSION(jpi,jpj) :: &
+         & zerrgcb, zerrgcx
+
+      ! Allocate memory
+
+      ALLOCATE( &
+         & zgcb_tlin( jpi,jpj),     &
+         & zgcx_tlin( jpi,jpj),     &
+         & zgcb_out ( jpi,jpj),     &
+         & zgcx_out ( jpi,jpj),     &
+         & zgcb_wop ( jpi,jpj),     &
+         & zgcx_wop ( jpi,jpj),     &
+         & zr(        jpi,jpj)      &
+         & )
+      !==================================================================
+      ! 1) dx = ( un_tl, vn_tl, hdivn_tl ) and 
+      !    dy = ( hdivb_tl, hdivn_tl )
+      !==================================================================
+
+      !--------------------------------------------------------------------
+      ! Reset the tangent and adjoint variables
+      !--------------------------------------------------------------------
+      zgcb_tlin( :,:) = 0.0_wp
+      zgcx_tlin( :,:) = 0.0_wp
+      zgcb_out ( :,:) = 0.0_wp
+      zgcx_out ( :,:) = 0.0_wp
+      zgcb_wop ( :,:) = 0.0_wp
+      zgcx_wop ( :,:) = 0.0_wp
+      zr(        :,:) = 0.0_wp
+
+      !--------------------------------------------------------------------
+      ! Initialize the tangent input with random noise: dx
+      !--------------------------------------------------------------------
+
+      !--------------------------------------------------------------------
+      ! Output filename Xn=F(X0)
+      !--------------------------------------------------------------------
+      CALL tlm_namrd
+      gamma = h_ratio   
+      file_wop='trj_wop_solsor'
+      file_xdx='trj_xdx_solsor'
+      !--------------------------------------------------------------------
+      ! Initialize the tangent input with random noise: dx
+      !--------------------------------------------------------------------
+      IF (( cur_loop .NE. 0) .OR. ( gamma .NE. 0.0_wp) )THEN
+         CALL grid_rd_sd( 596035, zr,  c_solver_pt, 0.0_wp, stdgc)    
+         DO jj = nldj, nlej
+            DO ji = nldi, nlei
+               zgcb_tlin(ji,jj) = zr(ji,jj)
+            END DO
+         END DO     
+         CALL grid_rd_sd( 264792, zr,  c_solver_pt, 0.0_wp, stdgc)    
+         DO jj = nldj, nlej
+            DO ji = nldi, nlei
+               zgcx_tlin(ji,jj) = zr(ji,jj)
+            END DO
+         END DO
+      ENDIF
+
+      !--------------------------------------------------------------------
+      ! Complete Init for Direct
+      !-------------------------------------------------------------------
+      CALL istate_p
+
+      ! *** initialize the reference trajectory
+      ! ------------
+
+!      gcx  (:,:) = ( ua(:,:,1) + ub(:,:,1) ) / 10.0_wp
+!      gcb  (:,:) = ( ua(:,:,3) + ub(:,:,3) ) / 10.0_wp
+      CALL  trj_rea( nit000-1, 1 ) 
+      CALL  trj_rea( nit000, 1 )
+      gcx  (:,:) =  un(:,:,1) / 10.0_wp
+      gcb  (:,:) =  un(:,:,3) / 10.0_wp
+
+      IF (( cur_loop .NE. 0) .OR. ( gamma .NE. 0.0_wp) )THEN
+         zgcb_tlin(:,:) = gamma * zgcb_tlin(:,:)
+         gcb(:,:)       = gcb(:,:) + zgcb_tlin(:,:)
+
+         zgcx_tlin(:,:) = gamma * zgcx_tlin(:,:)
+         gcx(:,:)       = gcx(:,:) + zgcx_tlin(:,:)
+      ENDIF 
+
+      !--------------------------------------------------------------------
+      !  Compute the direct model F(X0,t=n) = Xn
+      !--------------------------------------------------------------------
+      kindic=0
+      ncut=1
+      IF ( tlm_bch /= 2 ) CALL sol_sor(kindic)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
+      !--------------------------------------------------------------------
+      !  Compute the Tangent 
+      !--------------------------------------------------------------------
+      IF ( tlm_bch == 2 ) THEN
+         !--------------------------------------------------------------------
+         ! Initialize the tangent variables: dy^* = W dy  
+         !--------------------------------------------------------------------
+         gcr_tl(:,:) = 0.0_wp
+         gcb_tl  (:,:) = zgcb_tlin  (:,:)
+         gcx_tl  (:,:) = zgcx_tlin  (:,:)
+
+         !-----------------------------------------------------------------------
+         !  Initialization of the dynamics and tracer fields for the tangent
+         !-----------------------------------------------------------------------
+         ncut=1 !reset indicator of solver convergence
+         CALL sol_sor_tan(nit000, kindic)
+         !--------------------------------------------------------------------
+         ! Compute the scalar product: ( L(t0,tn) gamma dx0 ) )
+         !--------------------------------------------------------------------
+
+         zsp_gcx    = DOT_PRODUCT( gcx_tl, gcx_tl  )
+         zsp2       = zsp_gcx
+         !--------------------------------------------------------------------
+         !  Storing data
+         !--------------------------------------------------------------------
+         CALL trj_rd_spl(file_wop) 
+         zgcx_wop  (:,:) = gcx  (:,:)
+         CALL trj_rd_spl(file_xdx) 
+         zgcx_out  (:,:) = gcx  (:,:)
+         !--------------------------------------------------------------------
+         ! Compute the Linearization Error 
+         ! Nn = M( X0+gamma.dX0, t0,tn) - M(X0, t0,tn)
+         ! and 
+         ! Compute the Linearization Error 
+         ! En = Nn -TL(gamma.dX0, t0,tn)
+         !--------------------------------------------------------------------
+         ! Warning: Here we re-use local variables z()_out and z()_wop
+         ii=0
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zgcx_out   (ji,jj) = zgcx_out    (ji,jj) - zgcx_wop  (ji,jj)
+               zgcx_wop   (ji,jj) = zgcx_out    (ji,jj) - gcx_tl    (ji,jj)
+               IF (  gcx_tl(ji,jj) .NE. 0.0_wp ) zerrgcx(ji,jj) = zgcx_out(ji,jj)/gcx_tl(ji,jj)
+               IF( (MOD(ji, isamp) .EQ. 0) .AND. &
+               &   (MOD(jj, jsamp) .EQ. 0) ) THEN
+                   ii = ii+1
+                   iiposgcx(ii) = ji
+                   ijposgcx(ii) = jj
+                   IF ( INT(tmask(ji,jj,1)) .NE. 0)  THEN
+                      zscgcx (ii)    =  zgcx_wop(ji,jj)
+                      zscerrgcx (ii) =  ( zerrgcx(ji,jj) - 1.0_wp ) / gamma
+                   ENDIF
+               ENDIF
+            END DO
+         END DO
+
+         zsp_gcx   = DOT_PRODUCT( zgcx_out, zgcx_out  )
+
+         zsp1      = zsp_gcx
+
+         zsp_gcx   = DOT_PRODUCT( zgcx_wop, zgcx_wop  )
+
+         zsp3      = zsp_gcx
+         !--------------------------------------------------------------------
+         ! Print the linearization error En - norme 2
+         !--------------------------------------------------------------------
+         ! 14 char:'12345678901234'
+         cl_name = 'sol_sor: En   '
+         zsp    = SQRT(zsp3)
+         zgsp5   = zsp
+         CALL prntst_tlm( cl_name, kumadt, zsp, h_ratio )
+
+         !--------------------------------------------------------------------
+         ! Compute TLM norm2
+         !--------------------------------------------------------------------
+         zsp      = SQRT(zsp2)
+
+         zgsp4    = zsp
+         cl_name  = 'sol_sor: Ln2 '
+         CALL prntst_tlm( cl_name, kumadt, zsp, h_ratio )
+
+         !--------------------------------------------------------------------
+         ! Print the linearization error Nn - norme 2
+         !--------------------------------------------------------------------
+         zsp     = SQRT(zsp1)
+
+         cl_name = 'solsor:Mhdx-Mx'
+         CALL prntst_tlm( cl_name, kumadt, zsp, h_ratio )
+
+         zgsp3    = SQRT( zsp3/zsp2 )
+         zgsp7    = zgsp3/gamma
+         zgsp1    = zsp
+         zgsp2    = zgsp1 / zgsp4
+         zgsp6    = (zgsp2 - 1.0_wp)/gamma
+
+         FMT = "(A8,2X,I4.4,2X,E6.1,2X,E20.13,2X,E20.13,2X,E20.13,2X,E20.13,2X,E20.13,2X,E20.13,2X,E20.13)"
+         WRITE(numtan,FMT) 'solsor  ', cur_loop, h_ratio, zgsp1, zgsp2, zgsp3, zgsp4, zgsp5, zgsp6, zgsp7
+         !--------------------------------------------------------------------
+         ! Unitary calculus
+         !--------------------------------------------------------------------
+         FMT = "(A8,2X,A8,2X,I4.4,2X,E6.1,2X,I4.4,2X,I4.4,2X,I4.4,2X,E20.13,1X)"
+         cl_name ='sol_sor '
+         IF(lwp) THEN
+            DO ii=1, 100, 1
+               IF ( zscgcx(ii) .NE. 0.0_wp ) WRITE(numtan_sc,FMT) cl_name, 'zscgcx    ', &
+                    & cur_loop, h_ratio, ii, iiposgcx(ii), ijposgcx(ii), zscgcx(ii)
+            ENDDO
+            DO ii=1, 100, 1
+               IF ( zscerrgcx(ii) .NE. 0.0_wp ) WRITE(numtan_sc,FMT) cl_name, 'zscerrgcx ', &
+                    & cur_loop, h_ratio, ii, iiposgcx(ii), ijposgcx(ii), zscerrgcx(ii)
+            ENDDO
+            ! write separator
+            WRITE(numtan_sc,"(A4)") '===='
+         ENDIF
+
+      ENDIF
+
+      DEALLOCATE(      &
+         & zgcb_tlin,  &
+         & zgcx_tlin,  &
+         & zgcb_out ,  &
+         & zgcx_out ,  &
+         & zgcb_wop ,  &
+         & zgcx_wop ,  &
+         & zr          &
+         & )
+#else
+      !! * Arguments
+      INTEGER, INTENT(IN) :: &
+         & kumadt             ! Output unit
+      ! dummy routine
+#endif
+   END SUBROUTINE sol_sor_tlm_tst
+#endif   
 END MODULE solsor_tam
